'From Cuis 4.2 of 25 July 2013 [latest update: #2390] on 27 June 2015 at 9:44:32.337342 am'!

!RopeTextModel methodsFor: 'file handeling' stamp: 'jmv 6/27/2015 09:39'!
saveToNewFileNotifying: aTextModelMorph
	"Answer true if OK, else nil"

	| dialogResult |	
	dialogResult := (StandardFileMenu new) 
   					newFileFrom: (FileDirectory currentDirectory)
					withPattern: '*' ; 
					startUpWithCaption: 'Type new file name for save'.
	
	(dialogResult isNil)
	ifTrue: [ ^nil ]
	ifFalse: [ | fileStream  |
		fileName := (dialogResult directory) fullPathFor: (dialogResult name).
		fileStream := FileStream newFileNamed: fileName.
		fileStream nextPutAll: (self actualContents asString asString); close.
		timeStamp := (FileDirectory on: fileName) directoryEntry modificationDateAndTime.
		"@@@FIXME Notify aTextModelMorph"
		^true
	]! !


!RopeTextModel class methodsFor: 'instance creation' stamp: 'jmv 6/27/2015 09:39'!
fromUser
	"Put up a StandardFileMenu and let the user choose a file to read into me."
	"Answer an instance of me or nil"
"
	RopeTextModel fromUser.
"	
	| dialogResult slash textModel |
	dialogResult := (StandardFileMenu new)
						oldFileFrom: (FileDirectory currentDirectory) ;
	 					startUpWithCaption: 'Select a UTF-8 Unicode text file'.
	
	((dialogResult isNil) or: [dialogResult isDirectory]) ifTrue: [ ^nil ].

	slash := FileDirectory slash.

	textModel := self new initialize 
		fromFile: ( (dialogResult directory fullName) , slash , (dialogResult name) ).
		
	SystemWindow 
		editText: textModel
			label: 'Text Editor (''',  (dialogResult name) ,  ''')'
			wrap: true.
	
	^ textModel! !


!LazyFileRope methodsFor: 'private' stamp: 'jmv 6/27/2015 09:44'!
fileCleanup
	"Close and remove tempFile"

	 | fn |
	fn := fileStream name.
	fileStream close.
	fileStream directory deleteFileNamed: fn.! !

!LazyFileRope methodsFor: 'private' stamp: 'jmv 6/27/2015 09:39'!
genTempFileName
	"Answer the name of a file which is different than one that exists"
	
	"@@FIXME: Use /tmp on Unix, ??? on Windows"
	
	| dir looking rand fileName |
	
	looking := true.
	dir := FileDirectory currentDirectory.
	[looking] whileTrue: [
		 rand := 777 atRandom: (Random new initialize).
 		 fileName := 'tmp' , rand asString.
 		 looking := dir fileExists: fileName.
	].
	^ fileName
! !

!LazyFileRope methodsFor: 'initialize-release' stamp: 'jmv 6/27/2015 09:39'!
initializeFromFile: aName
	
	| tmpFileName |
	super initialize.
	"As Ropes are immutable, copy the file"
	tmpFileName := self genTempFileName.
	FileDirectory currentDirectory copyFileNamed: aName toFileNamed: tmpFileName.
	
	"Open a FileStream on the copy"
	fileName := aName.
	totalCount := nil.
	fileStream := FileStream readOnlyFileNamed: tmpFileName.
	soFar := (fileStream next: ChunkSize) asRope..
	
	^self
	! !


!LazyFileRope class methodsFor: 'instance creation' stamp: 'jmv 6/27/2015 09:40'!
onFileNamed: aName
	"Answer a new instance of me"
"
	(LazyFileString onFileNamed: 'test.txt') inspect.
"
	 | dirEntry |
	(FileDirectory currentDirectory fileExists: aName)
		ifFalse: [ ^ self error: 'Failed to find file ' , aName ].

	dirEntry := FileDirectory currentDirectory directoryEntryFor: aName.
	(dirEntry isDirectory) 
		ifTrue: [ ^self error: 'Not a text file: ' , aName ].
		
	((dirEntry fileSize) < ChunkSize)
	ifFalse: [ ^ self new initializeFromFile: aName ]
	ifTrue: [ | fileStream result |  "Too small to bother with"
		fileStream := FileStream readOnlyFileNamed: aName.
		 result := fileStream contentsOfEntireFile.
		^ result asRope
	 ]

	! !


!FileListWindow class methodsFor: '*ropes' stamp: 'jmv 6/27/2015 09:38'!
openRopeFileList
	"
	FileListWindow openRopeFileList
	"
	FileListWindow open: (RopeFileList new directory: FileDirectory currentDirectory) label: nil! !

