'From Cuis 4.2 of 25 July 2013 [latest update: #2390] on 27 June 2015 at 9:58:59.019065 am'!

!UniTextModel methodsFor: 'file handling' stamp: 'jmv 6/27/2015 09:56'!
fromFile: aFileName
	"Open the file aFileName if possible and read the file into actualContents.
	Answer self if successful else nil."
	
	| aFile fullPath |
	(aFileName isEmpty) ifFalse: [
		fullPath := (FileDirectory currentDirectory  fullPathFor:  aFileName).
		aFile := UniFileStream readOnlyFileNamed: fullPath.
		((aFile isNil) or: [ aFile isDirectory ]) ifFalse: [
			"Found a non-directory file; assume reable UTF-8"
			fileName := aFileName.
			timeStamp := aFile directoryEntry modificationDateAndTime.
			aFile close.
			actualContents := (UniLazyString onFileNamed: aFileName) asText.
			^self
		]
	].
	"Not a readable file"
	^nil

			! !

!UniTextModel methodsFor: 'file handling' stamp: 'jmv 6/27/2015 09:56'!
saveToNewFileNotifying: aTextModelMorph
	"Answer true if OK, else nil"

	| dialogResult |	
	dialogResult := (StandardFileMenu new) 
   					newFileFrom: (FileDirectory currentDirectory)
					withPattern: '*' ; 
					startUpWithCaption: 'Type new file name for save'.
	
	(dialogResult isNil)
	ifTrue: [ ^nil ]
	ifFalse: [ | uniFileStream  |
		fileName := (dialogResult directory) fullPathFor: (dialogResult name).
		uniFileStream := UniFileStream newFileNamed: fileName.
		uniFileStream nextPutAll: self actualContents asUniString; close.
		timeStamp := (FileDirectory on: fileName) directoryEntry modificationDateAndTime.
		"@@@FIXME Notify aTextModelMorph"
		^true
	]! !


!UniTextModel class methodsFor: 'instance creation' stamp: 'jmv 6/27/2015 09:57'!
fromUser
	"Put up a StandardFileMenu and let the user choose a file to read into me."
	"Answer an instance of me or nil"
"
	UniTextModel fromUser.
"		
	| dialogResult slash textModel |
	dialogResult := (StandardFileMenu new)
						oldFileFrom: (FileDirectory currentDirectory) ;
	 					startUpWithCaption: 'Select a UTF-8 Unicode text file'.
	
	((dialogResult isNil) or: [dialogResult isDirectory]) ifTrue: [ ^nil ].

	slash := FileDirectory slash.

	textModel := self new initialize 
		fromFile: ( (dialogResult directory fullName) , slash , (dialogResult name) ).
		
	SystemWindow 
		editText: textModel
			label: 'Unicode Text(''',  (dialogResult name) ,  ''')'
			wrap: true.
	
	^ textModel! !


!UniLazyString methodsFor: 'private' stamp: 'jmv 6/27/2015 09:58'!
fileCleanup
	"Close and remove tempFile"

	 | theFileName |
	theFileName := uniFileStream name.
	uniFileStream close.
	uniFileStream directory deleteFileNamed: theFileName.! !

!UniLazyString methodsFor: 'private' stamp: 'jmv 6/27/2015 09:56'!
genTempFileName
	"Answer the name of a file which is different than one that exists"
	
	"@@FIXME: Use /tmp on Unix, ??? on Windows"
	
	| dir looking rand theFileName |
	
	looking := true.
	dir := FileDirectory currentDirectory.
	[looking] whileTrue: [
		 rand := 777 atRandom: (Random new initialize).
 		 theFileName := 'tmp' , rand asString.
 		 looking := dir fileExists: theFileName.
	].
	^ theFileName
! !

!UniLazyString methodsFor: 'initialize-release' stamp: 'jmv 6/27/2015 09:56'!
initializeFromFile: aName
	
	| tmpFileName |
	super initialize.
	"As UniStrings are immutable, copy the file"
	tmpFileName := self genTempFileName.
	FileDirectory currentDirectory copyFileNamed: aName toFileNamed: tmpFileName.
	
	"Open a UniFileStream on the copy"
	fileName := aName.
	totalCount := nil.
	uniFileStream := UniFileStream readOnlyFileNamed: tmpFileName.
	soFar := uniFileStream nextUpTo: ChunkSize.
	
	^self
	! !


!UniLazyString class methodsFor: 'instance creation' stamp: 'jmv 6/27/2015 09:57'!
onFileNamed: aName
	"Answer a new instance of me"
"
ls := (UniLazyString onFileNamed: 'Pasted.utf8').
ls := (UniLazyString onFileNamed: 'test-utf8.txt').
"
	 | dirEntry |
	(FileDirectory currentDirectory fileExists: aName)
		ifFalse: [ ^ self error: 'Failed to find file ' , aName ].

	dirEntry := FileDirectory currentDirectory directoryEntryFor: aName.
	(dirEntry isDirectory) 
		ifTrue: [ ^self error: 'Not a text file: ' , aName ].
		
	((dirEntry fileSize) < ChunkSize)
	ifTrue: [ ^ UniString fromFile: aName ] "Too small to bother with"
	ifFalse: [ ^ self new initializeFromFile: aName ]

	! !


!FileListWindow class methodsFor: '*unicodes' stamp: 'jmv 6/27/2015 09:56'!
openUniFileList
	"Answer a FileList which can view Unicode"
	"
	FileListWindow openUniFileList.
	"
	FileListWindow open: (UniFileList new directory: FileDirectory currentDirectory ) label: nil! !

